Proxmox/setup/pihole-install.sh

134 lines
3.4 KiB
Bash
Raw Normal View History

2022-04-25 17:18:04 +02:00
#!/usr/bin/env bash
export DEBIAN_FRONTEND=noninteractive
2022-10-30 02:04:45 +01:00
YW=$(echo "\033[33m")
RD=$(echo "\033[01;31m")
BL=$(echo "\033[36m")
GN=$(echo "\033[1;92m")
CL=$(echo "\033[m")
2022-03-11 04:25:55 +01:00
RETRY_NUM=10
2022-03-09 01:09:46 +01:00
RETRY_EVERY=3
NUM=$RETRY_NUM
2022-04-19 09:39:57 +02:00
CM="${GN}${CL}"
CROSS="${RD}${CL}"
BFR="\\r\\033[K"
HOLD="-"
2022-04-25 20:07:12 +02:00
set -o errexit
set -o errtrace
set -o nounset
set -o pipefail
shopt -s expand_aliases
alias die='EXIT=$? LINE=$LINENO error_exit'
trap die ERR
function error_exit() {
trap - ERR
Correct Spelling (#360) * Update adguard-install.sh * Update daemonsync-install.sh * Update dashy-install.sh * Update debian-install.sh * Update deconz-install.sh * Update docker-install.sh * Update esphome-install.sh * Update grafana-install.sh * Update heimdalldashboard-install.sh * Update homeassistant-install.sh * Update homebridge-install.sh * Update influxdb-install.sh * Update iobroker-install.sh * Update jellyfin-install.sh * Update keycloak-install.sh * Update magicmirror-install.sh * Update mariadb-install.sh * Update meshcentral-install.sh * Update motioneye-install.sh * Update mqtt-install.sh * Update nginx-proxy-manager-install.sh * Update nocodb-install.sh * Update node-red-install.sh * Update omada-install.sh * Update openhab-install.sh * Update photoprism-install.sh * Update pihole-install.sh * Update plex-install.sh * Update podman-homeassistant-install.sh * Update postgresql-install.sh * Update prometheus-install.sh * Update technitiumdns-install.sh * Update ubuntu-install.sh * Update unifi-install.sh * Update uptimekuma-install.sh * Update vaultwarden-install.sh * Update whoogle-install.sh * Update wireguard-install.sh * Update zigbee2mqtt-install.sh * Update zwavejs2mqtt-install.sh * Update adguard-v3.sh * Update create_lxc.sh * Update daemonsync-v3.sh * Update dashy-v3.sh * Update debian-v3.sh * Update deconz-v3.sh * Update docker-v3.sh * Update esphome-v3.sh * Update grafana-v3.sh * Update heimdalldashboard-v3.sh * Update homeassistant-v3.sh * Update homebridge-v3.sh * Update influxdb-v3.sh * Update iobroker-v3.sh * Update jellyfin-v3.sh * Update keycloak-v3.sh * Update magicmirror-v3.sh * Update mariadb-v3.sh * Update meshcentral-v3.sh * Update motioneye-v3.sh * Update mqtt-v3.sh * Update nginx-proxy-manager-v3.sh * Update nocodb-v3.sh * Update node-red-v3.sh * Update omada-v3.sh * Update openhab-v3.sh * Update photoprism-v3.sh * Update pihole-v3.sh * Update plex-v3.sh * Update podman-homeassistant-v3.sh * Update postgresql-v3.sh * Update prometheus-v3.sh * Update technitiumdns-v3.sh * Update ubuntu-v3.sh * Update unifi-v3.sh * Update uptimekuma-v3.sh * Update vaultwarden-v3.sh * Update whoogle-v3.sh * Update wireguard-v3.sh * Update zigbee2mqtt-v3.sh * Update zwavejs2mqtt-v3.sh
2022-07-20 12:10:39 +02:00
local reason="Unknown failure occurred."
2022-04-25 20:07:12 +02:00
local msg="${1:-$reason}"
local flag="${RD}‼ ERROR ${CL}$EXIT@$LINE"
echo -e "$flag $msg" 1>&2
exit $EXIT
}
2022-04-19 09:39:57 +02:00
function msg_info() {
2022-10-30 02:04:45 +01:00
local msg="$1"
echo -ne " ${HOLD} ${YW}${msg}..."
2022-04-19 09:39:57 +02:00
}
function msg_ok() {
2022-10-30 02:04:45 +01:00
local msg="$1"
echo -e "${BFR} ${CM} ${GN}${msg}${CL}"
2022-04-19 09:39:57 +02:00
}
2022-03-09 01:09:46 +01:00
2022-08-31 11:20:58 +02:00
function msg_error() {
2022-10-30 02:04:45 +01:00
local msg="$1"
echo -e "${BFR} ${CROSS} ${RD}${msg}${CL}"
2022-08-31 11:20:58 +02:00
}
2022-04-19 09:39:57 +02:00
msg_info "Setting up Container OS "
2022-03-09 01:09:46 +01:00
sed -i "/$LANG/ s/\(^# \)//" /etc/locale.gen
locale-gen >/dev/null
while [ "$(hostname -I)" = "" ]; do
2022-10-30 02:04:45 +01:00
echo 1>&2 -en "${CROSS}${RD} No Network! "
2022-03-09 01:09:46 +01:00
sleep $RETRY_EVERY
((NUM--))
2022-10-30 02:04:45 +01:00
if [ $NUM -eq 0 ]; then
echo 1>&2 -e "${CROSS}${RD} No Network After $RETRY_NUM Tries${CL}"
2022-03-09 01:09:46 +01:00
exit 1
fi
done
2022-04-19 09:39:57 +02:00
msg_ok "Set up Container OS"
msg_ok "Network Connected: ${BL}$(hostname -I)"
2022-03-09 01:09:46 +01:00
2022-10-22 11:52:33 +02:00
set +e
alias die=''
2022-10-30 02:04:45 +01:00
if nc -zw1 8.8.8.8 443; then msg_ok "Internet Connected"; else
msg_error "Internet NOT Connected"
read -r -p "Would you like to continue anyway? <y/N> " prompt
if [[ $prompt == "y" || $prompt == "Y" || $prompt == "yes" || $prompt == "Yes" ]]; then
echo -e " ⚠️ ${RD}Expect Issues Without Internet${CL}"
else
echo -e " 🖧 Check Network Settings"
exit 1
fi
2022-10-30 02:04:45 +01:00
fi
2022-08-31 11:20:58 +02:00
RESOLVEDIP=$(nslookup "github.com" | awk -F':' '/^Address: / { matched = 1 } matched { print $2}' | xargs)
2022-10-30 02:04:45 +01:00
if [[ -z "$RESOLVEDIP" ]]; then msg_error "DNS Lookup Failure"; else msg_ok "DNS Resolved github.com to $RESOLVEDIP"; fi
2022-10-22 11:52:33 +02:00
alias die='EXIT=$? LINE=$LINENO error_exit'
set -e
2022-08-31 11:20:58 +02:00
2022-04-19 09:39:57 +02:00
msg_info "Updating Container OS"
2022-07-11 13:24:44 +02:00
apt-get update &>/dev/null
2022-08-30 00:43:55 +02:00
apt-get -y upgrade &>/dev/null
2022-04-19 09:39:57 +02:00
msg_ok "Updated Container OS"
2022-03-09 02:35:01 +01:00
2022-04-19 09:39:57 +02:00
msg_info "Installing Dependencies"
apt-get install -y curl &>/dev/null
apt-get install -y sudo &>/dev/null
2022-07-11 13:24:44 +02:00
apt-get install -y ufw &>/dev/null
apt-get install -y ntp &>/dev/null
2022-04-19 09:39:57 +02:00
msg_ok "Installed Dependencies"
2022-03-09 01:09:46 +01:00
2022-04-19 09:39:57 +02:00
msg_info "Installing Pi-hole"
mkdir -p /etc/pihole/
2022-10-30 02:04:45 +01:00
cat <<EOF >/etc/pihole/setupVars.conf
PIHOLE_INTERFACE=eth0
PIHOLE_DNS_1=8.8.8.8
PIHOLE_DNS_2=8.8.4.4
QUERY_LOGGING=true
INSTALL_WEB_SERVER=true
INSTALL_WEB_INTERFACE=true
LIGHTTPD_ENABLED=true
CACHE_SIZE=10000
DNS_FQDN_REQUIRED=true
DNS_BOGUS_PRIV=true
DNSMASQ_LISTENING=local
WEBPASSWORD=$(openssl rand -base64 48)
BLOCKING_ENABLED=true
EOF
curl -sSL https://install.pi-hole.net | bash /dev/stdin --unattended &>/dev/null
2022-04-19 09:39:57 +02:00
msg_ok "Installed Pi-hole"
2022-03-09 01:09:46 +01:00
2022-10-30 02:04:45 +01:00
PASS=$(grep -w "root" /etc/shadow | cut -b6)
if [[ $PASS != $ ]]; then
msg_info "Customizing Container"
rm /etc/motd
rm /etc/update-motd.d/10-uname
touch ~/.hushlogin
GETTY_OVERRIDE="/etc/systemd/system/container-getty@1.service.d/override.conf"
mkdir -p $(dirname $GETTY_OVERRIDE)
cat <<EOF >$GETTY_OVERRIDE
2022-03-09 01:09:46 +01:00
[Service]
ExecStart=
ExecStart=-/sbin/agetty --autologin root --noclear --keep-baud tty%I 115200,38400,9600 \$TERM
EOF
2022-10-30 02:04:45 +01:00
systemctl daemon-reload
systemctl restart $(basename $(dirname $GETTY_OVERRIDE) | sed 's/\.d//')
msg_ok "Customized Container"
fi
2022-04-19 09:39:57 +02:00
msg_info "Cleaning up"
2022-03-09 01:09:46 +01:00
apt-get autoremove >/dev/null
apt-get autoclean >/dev/null
2022-04-19 09:39:57 +02:00
msg_ok "Cleaned"